#!/bin/sh

startdir=`pwd`

cd happstack-docs
destdir=`pwd`

tmp=`mktemp -d`

gendocs () {
    cd $tmp
    if [ -e "$startdir/$1-$2.tar.gz" ]; then cp $startdir/$1-$2* .; tar xf $1-$2*;
            else cabal unpack $1;
    fi
    cd $1*
    if [ -n "$3" ]; then flags="--flags='$3'";
    fi
    runhaskell Setup configure --user $flags
    runhaskell  Setup haddock --hyperlink-source --html-location='http://happstack.com/docs/0.4/$pkg'
    cp dist/doc/html/*/*.haddock $destdir
    rsync -a dist/doc/html/ $destdir
}

gendocs happstack
gendocs happstack-data
#gendocs happstack-helpers
gendocs happstack-ixset
gendocs happstack-server
gendocs happstack-state
gendocs happstack-util
gendocs HStringTemplate
gendocs sendfile

rm -r $tmp

cd $destdir
for name in */; do
    for x in ${name}*.haddock; do
        n=`echo $name | tr -d '/'`
        haddock_args="$haddock_args --read-interface=$n,$x"
    done
done
echo $haddock_args
haddock -t 'Happstack' --gen-contents --gen-index -o . --prologue prologue.txt $haddock_args
